<?php

namespace Teknisa\TCO\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\Report\ReportService;

class Tco01100RelatoriosPropostaComercial extends \Zeedhi\Framework\Controller\Report {
    
    protected $reportService; 
    protected $environment; 
    protected $birtStrategy; 
    
    public function __construct($reportService, $environment, $birtStrategy) {
        $this->reportService = $reportService; 
        $this->environment = $environment; 
        $this->birtStrategy = $birtStrategy; 
    }
    
    protected $reportMapping = array ( 
        'TCO01100' =>
            array (
                'strategy' => 'BIRT',
                'parameterMapping' =>
                    array (
                        'NRPROPOSTACOMERCIAL' => 'NRPROPOSTACOMERCIAL',
                        'NRORG'               => 'NRORG'
                    )
            ),
        'TCO01101' =>
            array (
                'strategy' => 'BIRT',
                'parameterMapping' =>
                    array (
                        'NRPROPOSTACOMERCIAL' => 'NRPROPOSTACOMERCIAL',
                        'NRVERSAOPROPCOM'     => 'NRVERSAOPROPCOM',
                        'NRORG'               => 'NRORG'
                    )
            ),
        'TCO01102' =>
            array (
                'strategy' => 'BIRT',
                'parameterMapping' =>
                    array (
                        'NRPROPOSTACOMERCIAL' => 'NRPROPOSTACOMERCIAL',
                        'NRVERSAOPROPCOM'     => 'NRVERSAOPROPCOM',
                        'NRSERVICOPROPCOM'    => 'NRSERVICOPROPCOM',
                        'NRORG'               => 'NRORG'
                    )
            ),
        'TCO01103' =>
            array (
                'strategy' => 'BIRT',
                'parameterMapping' =>
                    array (
                        'NRPROPOSTACOMERCIAL'  => 'NRPROPOSTACOMERCIAL',
                        'NRVERSAOPROPCOM'      => 'NRVERSAOPROPCOM',
                        'NRSERVICOPROPCOM'     => 'NRSERVICOPROPCOM',
                        'NRDETALHESERVPROPCOM' => 'NRDETALHESERVPROPCOM',
                        'NRHISTNOTIFPROPCOM'   => 'NRHISTNOTIFPROPCOM',
                        'NRORG'                => 'NRORG'
                    )
            )
    );
    
    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {
        $row = $request->getRow();
        $row["__report_name"] = $row["REPORT_NAME"];
        $row["NRORG"] = $this->environment->getNrorgTrab();
    }
}