<?php
namespace Teknisa\TCO\Controllers;

use Zeedhi\Framework\Controller\Report as ReportController;
use Zeedhi\Framework\DTO\Request\Row;
use Zeedhi\Framework\DTO\Response;

class Tco01200CardapioDaPropostaReport extends ReportController {
    protected $reportService;
    protected $birtStrategy;

    protected $reportMapping = array(
        'TCO01200' => array(
            'strategy' => 'BIRT',
            'parameterMapping' => array(
                'NRCARDAPIOTRAB'      => 'P_NRCARDAPIOTRAB',
                'DTLANCAMENTO'        => 'P_DTLANCAMENTO',
                'NRPROPOSTACOMERCIAL' => 'P_NRPROPOSTACOMERCIAL',
                'CDPRATOINICIAL'      => 'P_CDPRATOINICIAL',
                'CDPRATOFINAL'        => 'P_CDPRATOFINAL',
                'CDARVPRODINICIAL'    => 'P_CDARVPRODINICIAL',
                'NRPROPOSTACOMERCIAL' => 'P_NRPROPOSTACOMERCIAL',
                'CDARVPRODFINAL'      => 'P_CDARVPRODFINAL',
                'NRORG'               => 'P_NRORG'
            )
        ),
        'TCO01201' => array(
            'strategy' => 'BIRT',
            'parameterMapping' => array(
                'NRCARDAPIOTRAB'      => 'P_NRCARDAPIOTRAB',
                'DTLANCAMENTO'        => 'P_DTLANCAMENTO',
                'NRPROPOSTACOMERCIAL' => 'P_NRPROPOSTACOMERCIAL',
                'CDPRATOINICIAL'      => 'P_CDPRATOINICIAL',
                'CDPRATOFINAL'        => 'P_CDPRATOFINAL',
                'NRORG'               => 'P_NRORG'
            )
        )
    );

    public function __construct($reportService, $birtStrategy, $environment){
        $this->reportService = $reportService;
        $this->birtStrategy = $birtStrategy;
        $this->environment = $environment;
    }

    public function beforeProcessReport(Row $request, Response $response) {
        $row = $request->getRow();
        $row['NRORG'] = $this->environment->getNrOrg();
        
        $row['CDPRATOINICIAL'] = $row['CDPRATOINICIAL'] ?? "0"; // check key exists
        $row['CDPRATOINICIAL'] = empty($row['CDPRATOINICIAL']) ? "0" : $row['CDPRATOINICIAL']; 
            // check empty value
        
        $row['CDARVPRODINICIAL'] = $row['CDARVPRODINICIAL'] ?? "0";
        $row['CDARVPRODINICIAL'] = empty($row['CDARVPRODINICIAL']) ? "0" : $row['CDARVPRODINICIAL'];

        $row['CDPRATOFINAL'] = $row['CDPRATOFINAL'] ?? "";

        $row['CDARVPRODFINAL'] = $row['CDARVPRODFINAL'] ?? "";
        
        $row['CDPRATOFINAL'] = str_pad($row['CDPRATOFINAL'], 10, "z");
        $row['CDARVPRODFINAL'] = str_pad($row['CDARVPRODFINAL'], 20, "z");

        $row['__report_name'] = $row['REPORT'];
        $this->birtStrategy->setReportFormat($row['BIRTTYPE']);
    }
}